Subject: Re: bug#53981: 28.0.91; shortdoc: Add support for outline-minor-mode

From: Stefan Monnier <[email-masked]>
Date: Wed, 09 Nov 2022 14:47:56 -0500

>> BTW, the patch uses functions from text-property-search.el.
>> But these useful functions are still not autoloaded.
>> Here is the patch to autoload them:
>
> I don't necessarily disagree, but do we have any policies or
> guidelines regarding when to autoload a function?  It saves us a
> 'require', but what we "gain" instead is a (small) inflation of the
> base memory footprint of the Emacs process.  So it isn't free.
>
> Lars, Stefan, any comments?

For interactive functions, it's usually decided by whether the command
can be useful before the package is loaded (i,e,. usually an entry
point to the package).

For functions (i.e. exported from what is basically a library), the same
kind of tradeoff applies:

- is it likely that this one autoload will let other packages use this
  library without a `require` at all (e.g. `define-inline`), or will we
  end up needing N autoloads anyway?
- how commonly is this library used (i.e. is it worth carrying the
  N autoloads in every Emacs session, compared to having to write
  `require` in a handful of files).

        Stefan